#include <mist/mist.h>
#include <mist/io/image.h>
#include <mist/filter/linear.h>
#include <mist/filter/median.h>
#include <time.h>
#include <cmath>
#include <stdio.h>
#include "graph.h"

#define MASK 5
#define SHIFTMAX 255
#define SHIFTMIN 0
#define T 50
#define MEDIAN 3

int SAD( int i, int j, int d, const mist::array2< int > &left, const mist::array2< int > &right )
{
  // $B:9$N7W;;(B
  int sad;

  // $B@55,2=Aj8_Aj4XMQ(B
  //  double bunshi = 0, bunbo1 = 0, bunbo2 = 0, result = 0;

  // $B=i4|2=(B
  sad = 0;
  
  
  
  //  std::cout << " i " << i << std::endl; 
  //std::cout << " j " << j << std::endl; 

  if( i - d - MASK >= 0 && j > MASK && i + MASK < (int)left.width() && j + MASK < (int)left.height() )
    {

      //      std::cout << " i " << i-d << std::endl; 
      // $B$H$j$"$($:CmL\2hAG<~JU$N9g7W$r7W;;(B
      for ( int m = - MASK; m <= MASK; m++ )
	for( int n = - MASK; n <= MASK; n++ )
	  {
	    
	    // 	if( i < 0 )
	    // 	  std::cout << " i " << i << std::endl; 
	    
	    // $B:9$r7W;;$9$k(B SAD(sum. of absolue difference)$B$r;H$&(B		    
	    sad += abs( left( i + n , j + m ) - right( i - d + n, j + m ) );
	    
	    // SSD
	    //sad += ( left( i + n , j + m ) - right( i - d + n, j + m ) ) * ( left( i + n , j + m ) - right( i - d + n, j + m ) ) ;

	    //	    std::cout << " sad " << sad << std::endl; 
	    
// 	    // $B@55,2=Aj8_Aj4X(B
// 	    bunshi += (double)(left( i + m, j + n ) * right( i - d + m, j + n ));
// 	    bunbo1 += (double)(left( i + m, j + n ) * left( i + m, j + n ));
// 	    bunbo2 += (double)(right( i - d + m, j + n ) * right( i - d + m, j + n ));
	  }
      
//       result = bunshi / ( sqrt( bunbo1 * bunbo2 ) );
      
//       sad = (int)result;
    }
  //  sad = abs( left( i, j) - right( i - d, j) );

  return sad;

}

int main( int argc, char *argv[] )
{

  clock_t time1, time2;

  time1 = clock();

    // $B%=!<%Y%k%U%#%k%?$N=`Hw(B
    int fvd[ ] = 
      { 
        1,  1,  1, 
        0,  0,  0,
        -1, -1, -1 
      }; // $B=DJ}8~%(%C%8Cj=PMQ%^%9%/MWAG(B
  
    int fhd[ ] = 
      { 
        1, 0, -1, 
        1, 0, -1,
        1, 0, -1 
      }; // $B2#J}8~%(%C%8Cj=PMQ%^%9%/MWAG(B
  
    mist::array2< int > fv( 3, 3 );
    std::copy( fvd, fvd + 9, fv.begin( ) ); // fvd$B$NMWAG$r(Bfv$B$K%3%T!<(B
  
    mist::array2< int > fh( 3, 3 );
    std::copy( fhd, fhd + 9, fh.begin( ) ); // fhd$B$NMWAG$r(Bfh$B$K%3%T!<(B
  
  // $B2hA|$O%0%l!<%9%1!<%k7A<0$G07$&(B
  mist::array2< int > right, left;

  mist::array2< int > t_right, t_left;

  int dispmax; // $B:GBg;k:9(B

  if( argc != 4 )
    {
      std::cout << "$B;H$$J}(B ./GraphCut $B:82hA|(B $B1&2hA|(B $B:GBg;k:9(B" << std::endl;
      return 1;
    }

  // bmp$B7A<0$N1&2hA|!$:82hA|$rFI$_9~$`(B
  // $B1&2hA|FI$_9~$_(B
  if( mist::read_bmp( right, argv[2] ) )
    {
      std::cout << " Right Image Reading Success " << std::endl;
    }
  else
    {
      std::cout << " Right Image Reading Failure " << std::endl;
      exit(0);
    }

  // $B:82hA|FI$_9~$_(B
  if( mist::read_bmp( left, argv[1] ) )
    {
      std::cout << " Left Image Reading Success " << std::endl;
    }
  else
    {
      std::cout << " Left Image Reading Failure " << std::endl;
      exit(0);
    }

  // $B:GBg;k:9FI$_9~$_(B
  dispmax = atoi(argv[3]);

  // $B:GBg;k:9$+$iAm%i%Y%k?t(B(2$B$NN_>h(B)$B$r5a$a$k(B
  int max = 0, min = 10000, label;

  int j = 2;
  while( j < (int)left.width() )
    {
      label = abs( j - dispmax );
      
      if( min > label )
	{
	  min = label;
	  max = j;
	}
      else 
	break;

      j *= 2;
    }

  dispmax = max;
  fprintf(stderr, "dispmax = %d\n", dispmax);


  mist::array2< int > t_tmp( left.width(), left.height() );


  // $BDI2C(B
//   mist::median( t_right, right, MEDIAN, 0 );
//   mist::median( t_left, left, MEDIAN, 0 );


  // $B%0%l!<%9%1!<%k$KJQ49$5$l$?1&2hA|$r=PNO(B 
  mist::write_bmp( right, "r_grayscale.bmp" );

  // $B%0%l!<%9%1!<%k$KJQ49$5$l$?:82hA|$r=PNO(B 
  mist::write_bmp( left, "l_grayscale.bmp" );

  // out:$B=PNO%U%!%$%k(B
  mist::array2< int > out( left.width(), left.height() ), tmp( left.width(), left.height() ); 

  mist::array2< int > fx, fy, sobel;
  
  //$B%=!<%Y%k%U%#%k%?(B
  mist::linear_filter( left, fx, fh ); // fh$B$r%^%9%/$H$9$k@~7A%U%#%k%?!J2#J}8~(B1$B<!HyJ,!K(B
  mist::linear_filter( left, fy, fv ); // fv$B$r%^%9%/$H$9$k@~7A%U%#%k%?!J=DJ}8~(B1$B<!HyJ,!K(B
  
  sobel.resize( left.width( ), left.height( ) );
  
  for( size_t i = 0 ; i != sobel.size( ) ; ++ i )
    {
      sobel[ i ] = static_cast< int >( std::sqrt( ( fx[ i ] * fx[ i ] + fy[ i ] * fy[ i ] ) / 2.0 ) ); // $B=DJ}8~!$2#J}8~%(%C%86/EY9g@.(B
      
    }
  mist::write_bmp( sobel, "sobel.bmp" );
  

  int image_node_number, add_node_number, all_node_number, edge_number;

  // $B2hA|$rI=$9%N!<%I$N?t(B = $B2hA|$NI}(B * $B2hA|$N9b$5(B
  image_node_number = left.width() * left.height();

  // $B2hAG$H2hAG$N4V$KDI2C$9$k%N!<%I$N?t(B
  add_node_number = ( left.height() - 1 ) * left.width() + ( left.width() - 1 ) * left.height();
 
  // $B%N!<%I$N?t$N9g7W(B
  all_node_number = image_node_number + add_node_number;

  // $B%(%C%8$N?t(B
  edge_number = ( left.width() - 1 ) * 2 * left.height() + ( left.height() - 1 ) * 2 * left.width();

  fprintf(stderr, "node_number = %d\n", all_node_number);
  fprintf(stderr, "edge_number = %d\n", edge_number);

  
  /******************************$B3,AX%0%i%U%+%C%H$G%9%F%l%*(B****************************************/

  // $BJQ?t$N@k8@(B
  typedef Graph<int,int,int> GraphType;
  GraphType *g;

  // E = $B$H$F$bBg$-$JCM(B, k = $B%i%Y%k$N0LCV$r<($9(B
  int E = 1000000000, success, alpha, ap, d_bp, d_ap, aq, vap_bq, p_a, a_p, vbp_aq, a_q, q_a, k, vbp_bq, vap_aq,  bp, bq, c, difference, tdif;
  double keisan;
  //int c0 = 2, c1 = 2;

  // $B=i4|CM(B
  for( size_t j = 0; j < left.height(); j++)
    for( size_t i = 0; i < left.width(); i++)
      {
	//tmp( i, j ) = 16;
	tmp( i, j ) = 0;
      }

  /***********************$B3,AX9=B$$NG[Ns$r7W;;(B**********************/

  // $B3,AX9=B$$NG[Ns$NDj5A(B
  //$B$3$3$+$i(B
  int A[dispmax][dispmax]; // $B7W;;7k2L3JG<MQ(B
  int flag[dispmax]; // $B7W;;7k2L%A%'%C%/MQ(B
  int acount; // $B%i%Y%k$N8D?t(B
  int loopcheck; // $B7W;;=*N;>r7o%U%i%0N)$FMQ(B
  int labelcount = 0; // $B3,AX9=B$$NG[Ns$NAm8D?tMQ!!@bL@$7$K$/$$!&!&!&(B


  // $B7W;;7k2L3JG<MQ$NG[Ns$r=i4|2=(B
  for( int j = 0; j < dispmax; j++ )
    for( int i = 0; i < dispmax; i++ )
      {
	A[j][i] = 0; 
      }

  // $B%U%i%0$N=i4|2=(B
  for( int j = 0; j < dispmax; j++ )
    {
      flag[j] = 0; 
    }

  // $B3,AX9=B$$NG[Ns$r7W;;(B
  // $B9V5A;qNA;2>H(B
  A[0][0] = 0;
   fprintf( stderr, "A[%d][%d] = %d\n", 0, 0, A[0][0]);
  flag[0] = 1; // $B%U%i%0$rN)$F$k(B
  A[1][0] = ( dispmax ) / 2;
  fprintf( stderr, "A[%d][%d] = %d\n", 1, 0, A[1][0]);
  flag[ A[1][0] ] = 1; // $B%U%i%0$rN)$F$k(B

  for( int j = 1; j < E; j++ )
    {      
      loopcheck = 0; // $B%U%i%0$N=i4|CM(B
      acount = 1; // $B%i%Y%k8D?t$N=i4|CM(B

      // $B%k!<%W=*N;>r7o7W;;MQ(B $B%i%Y%k$N8D?t$r7W;;$9$k(B
      if( j != 1 )
	{
	  for( int a = 0; a < j - 1; a++ )
	    {
	      acount = acount * 2;
	    }
	}
      // fprintf(stderr, "acount = %d\n",acount);
      // $B$3$3$^$G(B

      // $B%i%Y%k$r7W;;(B
      // $B6v?t(B
      for( k = 0; k < acount; k++ )
	{	 
	  keisan = ( 1.0 + 4.0 * k ) / ( acount * 2.0 * 2.0 ) * dispmax;
	  A[2 * j][k] = (int)keisan;
	    fprintf( stderr, "A[%d][%d] = %d\n", 2*j, k, A[2*j][k]);
	  flag[ A[2 * j][k] ] = 1; // $B%U%i%0N)$F(B
	}

      // $BA4$F$N%i%Y%k$,=P8=$7$F$$$k$+%A%'%C%/(B
      for( int i = 0; i < dispmax; i++ )
	{
	  //fprintf( stderr, "flag%d = %d\n", i, flag[i]);
	  if( flag[i] == 0 )
	    loopcheck = 1; // $B$^$@=P$F$J$$%i%Y%k$,$"$C$?$i%U%i%0N)$F(B
	}
      
      // $B%i%Y%k$,A4It=P8=$7$?$iG[Ns$N8D?t$rJ]B8$7$F(Bbreak
      if ( loopcheck == 0 )
	{
	  labelcount = 2 * j + 1;
	  fprintf( stderr, "labelcount = %d\n", labelcount );
	  break;
	}

      loopcheck = 0; // $B%U%i%0$N=i4|CM(B

      fprintf( stderr, "\n");
      // $B4q?t(B
      for( k = 0; k < acount; k++ )
	{
	  keisan = ( 3.0 + 4.0 * k ) / ( acount * 2.0 * 2.0 ) * dispmax;
	  A[2 * j + 1][k] = (int)keisan;
	  flag[ A[2 * j + 1][k] ] = 1; // $B%U%i%0N)$F(B
	  fprintf( stderr, "A[%d][%d] = %d\n", 2*j+1, k, A[2*j+1][k]);
	}
      
      // $BA4$F$N%i%Y%k$,=P8=$7$F$$$k$+%A%'%C%/(B
      for( int i = 0; i < dispmax; i++ )
	{
	  //fprintf( stderr, "flag%d = %d\n", i, flag[i]);
	  if( flag[i] == 0 )
	    loopcheck = 1; // $B$^$@=P$F$J$$%i%Y%k$,$"$C$?$i%U%i%0N)$F(B
	}
      
      // $B%i%Y%k$,A4It=P8=$7$?$iG[Ns$N8D?t$rJ]B8$7$F(Bbreak
      if ( loopcheck == 0 )
	{
	  labelcount = 2 * j + 1;
	  fprintf( stderr, "labelcount = %d\n", labelcount );
	  break;
	}
      
    }

//   for( int i = 0; i < dispmax; i++ )
//     {
//       for( int j = 0; j < dispmax; j++ )
// 	{
// 	  fprintf(stderr, "%d ",A[i][j] );
// 	}
//       fprintf(stderr, "\n");
//     }
  /*********************************************/


  /************************$B3,AX%0%i%U%+%C%H(B***********************************/

  // $B$H$F$bBg$-$JCM$^$G%k!<%W(B
  for( int loop = 0; loop < E; loop++ )
    {
      success = 0;
   
      // for$B%k!<%W(B 0 $B$+$i(B $B3,AX9=B$$NG[Ns$N?t$^$G%k!<%W(B
      for( alpha = 0; alpha <= labelcount; alpha++ )
	{	  

	  //fprintf(stderr, "loop %d - %d\n",loop, alpha);

	  // $B%0%i%U$N=i4|2=(B
	  g = new GraphType(/*estimated # of nodes*/ all_node_number, 
			    /*estimated # of edges*/ edge_number); 

	  // $B%N!<%I$N?t$V$s@_Dj(B
	  g -> add_node(all_node_number); 


	  /*******$B%9%F%l%*%^%C%A%s%0$N0Y$N%G!<%?%3%9%H4X?t$NDj5A(B*******/
	  // $BLdBj$O(Bk$B$NCM!%(B
	  // $B$H$j$"$($:<x6H;qNA$K1h$C$?7A(B

	  // $B=i4|2=(B 
	  k = 0; 

	  for( size_t j = 0; j < left.height(); j++)
	    for( size_t i = 0; i < left.width(); i++)
	      {
		// k$B$NA}$d$7J}$,LdBj!%(B
		// $B$?$V$s$3$l$G9g$C$F$k$H;W$&$s$@$1$I!&!&!&(B
		k = j * ( left.width() + left.width() - 1 + left.width() ) + i * 2;

		// $B%G!<%?%3%9%H4X?t$N7W;;(B
		// $B$3$N$"$?$j$K%9%F%l%*%^%C%A$NMWAG$,F~$C$F$/$k(B

		// $B=i4|2=(B
		difference = 10000;
		tdif = 0;
		ap = 0;
		
		// $B&A(Bp$B$N7W;;(B
		for( int l = 0; l < 100; l++ )
		  {
		    if( A[alpha][l] != 0 )
		      {
			tdif = abs( tmp( i, j ) - A[alpha][l] );
			if( tdif < difference )
			  {
			    difference = tdif;
			    ap = l;
			  }
		      }
		    else
		      {
			break;
		      }
		  }

		//fprintf(stderr, "ap = %d , bp = %d\n", A[alpha][ap], tmp(i,j));

		// SAD$B$N7W;;(B
		d_bp = SAD( i, j, tmp( i, j ), left, right );
		d_ap = SAD( i, j, A[alpha][ap], left, right );

		//fprintf(stderr, "%d \n", d_ap);

		d_bp = abs( d_bp );
		d_ap = abs( d_ap );

		//fprintf(stderr, "%d \n", d_ap);
						
		// $B%N!<%I$N!$(BSOURCE$BB&$K(BD($B&B(Bp),SINK$BB&$K(BD($B&A(Bp)$B$r@_Dj(B
		// $B:G=*E*$K(Bsad$B$N7W;;7k2L$,%i%Y%k$K$J$k$N$+(B
		g -> add_tweights( k,   /* capacities */  d_bp, d_ap );
	
	      }
	  /****************************************************/	  



	  /********$B%9%F%l%*%^%C%A%s%0$N0Y$N%9%`!<%:%3%9%H$NDj5A(B********/

	  // $B=i4|2=(B
	  k = 0; 

	  for( size_t j = 0; j < left.height(); j++)
	    for( size_t i = 0; i < left.width() - 1; i++)
	      {
		// k$B$O$3$l$G$$$$$O$:!&!&!&(B
		k = j * ( left.width() + left.width() - 1 + left.width() ) + i * 2 + 1;

		// $B@:EY8~>e$N0Y$K(B
		if( sobel( i, j ) > T )
		  c = 1;
		else
		  c = 5;


		//c = 1;

		// A[alpha][]$B$N$&$A!$&B(Bp$B$K:G$b6a$$CM$r&A(Bp$B$K@_Dj(B
		// A[alpha][]$B$N$&$A!$&B(Bq$B$K:G$b6a$$CM$r&A(Bq$B$K@_Dj(B
		bp = tmp( i, j );
		bq = tmp( i+1, j );

		// $B=i4|2=(B
		ap = 0; 
		difference = 10000;
		tdif = 0;
		
		// $B&A(Bp,$B&A(Bq$B$N7W;;(B
		for( int l = 0; l < 100; l++ )
		  {
		    if( A[alpha][l] != 0 )
		      {
			tdif = abs( bp - A[alpha][l] );
			if( tdif < difference )
			  {
			    difference = tdif;
			    ap = l;
			  }
		      }
		    else
		      {
			break;
		      }

		  }

		// $B=i4|2=(B
		aq = 0; 
		difference = 10000;
		tdif = 0;

		for( int l = 0; l < 100; l++ )
		  {
		    if( A[alpha][l] != 0 )
		      {
			tdif = abs( bq - A[alpha][l] );
			if( tdif < difference )
			  {
			    difference = tdif;
			    aq = l;
			  }
		      }
		    else
		      {
			break;
		      }

		  }
       	   	    
		// $B%N!<%I(Ba$B$N!$(BSOURCE$BB&$K(BV($B&B(Bp, $B&B(Bq), SINK$BB&$K(BV($B&A(Bp, $B&A(Bq)$B$r@_Dj(B	       
		vbp_bq = c * abs( bp  - bq );
		vap_aq = c * abs( A[alpha][ap] - A[alpha][aq] );
		g -> add_tweights( k,   /* capacities */  vbp_bq, vap_aq );

		if( vbp_bq <= vap_aq )
		  {

		    // $B%N!<%I(Ba$B$+$i%N!<%I(Bp$B$N%(%C%8$N=E$_$K(B10000$B$r@_Dj(B
		    a_p = 10000;
		    
		    // $B%N!<%I(Bp$B$+$i%N!<%I(Ba$B$N%(%C%8$N=E$_$K(B, V($B&A(Bp, $B&B(Bq) - V($B&B(Bp, $B&B(Bq)$B$+(B0$B$N$&$ABg$-$$$[$&$r@_Dj(B
		    vap_bq = c * abs( A[alpha][ap] - bq );
		    vbp_bq = c * abs( bp - bq );

		    if( vap_bq - vbp_bq > 0 )
		      p_a = vap_bq - vbp_bq;
		    else
		      p_a = 0;

		    g -> add_edge( k - 1, k,   /* capacities */ p_a, a_p );

		    // $B%N!<%I(Ba$B$+$i%N!<%I(Bq$B$N%(%C%8$N=E$_$K(B10000$B$r@_Dj(B
		    a_q = 10000;

		    // $B%N!<%I(Bq$B$+$i%N!<%I(Ba$B$N%(%C%8$N=E$_$K(B, V($B&B(Bp, $B&A(Bq) - V($B&B(Bp, $B&B(Bq)$B$+(B0$B$N$&$ABg$-$$$[$&$r@_Dj(B
		    vbp_aq = c * abs( bp - A[alpha][aq] );

		    if( vbp_aq - vbp_bq > 0 )
		      q_a = vbp_aq - vbp_bq;
		    else
		      q_a = 0;

		    g -> add_edge( k, k + 1,   /* capacities */ a_q, q_a );
		    
		  }
		else if( vbp_bq >= vap_aq )
		  {

		    // $B%N!<%I(Bp$B$+$i%N!<%I(Ba$B$N%(%C%8$N=E$_$K(B10000$B$r@_Dj(B
		    p_a = 10000;
		    
		    // $B%N!<%I(Ba$B$+$i%N!<%I(Bp$B$N%(%C%8$N=E$_$K(B, V($B&B(Bp, $B&A(Bq) - V($B&A(Bp, $B&A(Bq)$B$+(B0$B$N$&$ABg$-$$$[$&$r@_Dj(B
		    vbp_aq = c * abs( bp - aq );
		    vap_aq = c * abs( A[alpha][ap] - A[alpha][aq] );

		    if( vbp_aq - vap_aq > 0 )
		      a_p = vbp_aq - vap_aq;
		    else
		      a_p = 0;

		    g -> add_edge( k - 1, k,   /* capacities */ p_a, a_p );

		    // $B%N!<%I(Bq$B$+$i%N!<%I(Ba$B$N%(%C%8$N=E$_$K(B10000$B$r@_Dj(B
		    q_a = 10000;

		    // $B%N!<%I(Ba$B$+$i%N!<%I(Bq$B$N%(%C%8$N=E$_$K(B, V($B&A(Bp, $B&B(Bq) - V($B&A(Bp, $B&A(Bq)$B$+(B0$B$N$&$ABg$-$$$[$&$r@_Dj(B
		    vap_bq = c * abs( A[alpha][ap] - bq );

		    if( vap_bq - vap_aq > 0 )
		      a_q = vap_bq - vap_aq;
		    else
		      a_q = 0;
   
		    g -> add_edge( k, k + 1,   /* capacities */ a_q, q_a );
		  }		     	
	      }
	  
	  
	  k = 0;
	  for( size_t j = 0; j < left.height() - 1; j++)
	    for( size_t i = 0; i < left.width(); i++)
	      {
		// k$B$O$3$l$G$$$$$O$:!&!&!&(B
		k = ( j + 1 ) * ( left.width() + left.width() - 1 ) + i + ( left.width() * j );

		// $B@:EY8~>e$N0Y$K(B
		if( sobel( i, j ) > T )
		  c = 1;
		else
		  c = 5;

		//c = 1;

		
// 		  fprintf(stderr, "k = %d\n", k);
// 		  fprintf(stderr, "$B>e(B = %d\n",j * ( left.width() + left.width() - 1 + left.width() ) + i * 2);
// 		  fprintf(stderr, "$B2<(B = %d\n",( j + 1 ) * ( left.width() + left.width() - 1 + left.width() ) + i * 2);
		

		bp = tmp( i, j );
		bq = tmp( i, j + 1 );

		// $B=i4|2=(B
		ap = 0; 
		difference = 10000;
		tdif = 0;

		// $B&A(Bp,$B&A(Bq$B$N7W;;(B
		for( int l = 0; l < 100; l++ )
		  {
		    if( A[alpha][l] != 0 )
		      {
			tdif = abs( bp - A[alpha][l] );
			if( tdif < difference )
			  {
			    difference = tdif;
			    ap = l;
			  }
		      }
		    else
		      {
			break;
		      }

		  }

		// $B=i4|2=(B
		aq = 0; 
		difference = 10000;
		tdif = 0;

		for( int l = 0; l < 100; l++ )
		  {
		    if( A[alpha][l] != 0 )
		      {
			tdif = abs( bq - A[alpha][l] );
			if( tdif < difference )
			  {
			    difference = tdif;
			    aq = l;
			  }
		      }
		    else
		      {
			break;
		      }

		  }
       	   	    
		// $B%N!<%I(Ba$B$N!$(BSOURCE$BB&$K(BV($B&B(Bp, $B&B(Bq), SINK$BB&$K(BV($B&A(Bp, $B&A(Bq)$B$r@_Dj(B	       
		vbp_bq = c * abs( bp  - bq );
		vap_aq = c * abs( A[alpha][ap] - A[alpha][aq] );

		if( vbp_bq <= vap_aq )
		  {

		    // $B%N!<%I(Ba$B$+$i%N!<%I(Bp$B$N%(%C%8$N=E$_$K(B10000$B$r@_Dj(B
		    a_p = 10000;
		    
		    // $B%N!<%I(Bp$B$+$i%N!<%I(Ba$B$N%(%C%8$N=E$_$K(B, V($B&A(Bp, $B&B(Bq) - V($B&B(Bp, $B&B(Bq)$B$+(B0$B$N$&$ABg$-$$$[$&$r@_Dj(B
		    vap_bq = c * abs( A[alpha][ap] - bq );
		    vbp_bq = c * abs( bp - bq );

		    if( vap_bq - vbp_bq > 0 )
		      p_a = vap_bq - vbp_bq;
		    else
		      p_a = 0;

		    g -> add_edge( j * ( left.width() + left.width() - 1 + left.width() ) + i * 2, k,   /* capacities */ p_a, a_p );

		    // $B%N!<%I(Ba$B$+$i%N!<%I(Bq$B$N%(%C%8$N=E$_$K(B10000$B$r@_Dj(B
		    a_q = 10000;

		    // $B%N!<%I(Bq$B$+$i%N!<%I(Ba$B$N%(%C%8$N=E$_$K(B, V($B&B(Bp, $B&A(Bq) - V($B&B(Bp, $B&B(Bq)$B$+(B0$B$N$&$ABg$-$$$[$&$r@_Dj(B
		    vbp_aq = c * abs( bp - A[alpha][aq] );

		    if( vbp_aq - vbp_bq > 0 )
		      q_a = vbp_aq - vbp_bq;
		    else
		      q_a = 0;

		    g -> add_edge( k, ( j + 1 ) * ( left.width() + left.width() - 1 + left.width() ) + i * 2,   /* capacities */ a_q, q_a );
		    
		  }
		else if ( vbp_bq >= vap_aq )
		  {

		    // $B%N!<%I(Bp$B$+$i%N!<%I(Ba$B$N%(%C%8$N=E$_$K(B10000$B$r@_Dj(B
		    p_a = 10000;
		    
		    // $B%N!<%I(Ba$B$+$i%N!<%I(Bp$B$N%(%C%8$N=E$_$K(B, V($B&B(Bp, $B&A(Bq) - V($B&A(Bp, $B&A(Bq)$B$+(B0$B$N$&$ABg$-$$$[$&$r@_Dj(B
		    vbp_aq = c * abs( bp - aq );
		    vap_aq = c * abs( A[alpha][ap] - A[alpha][aq] );

		    if( vbp_aq - vap_aq > 0 )
		      a_p = vbp_aq - vap_aq;
		    else
		      a_p = 0;

		    g -> add_edge( j * ( left.width() + left.width() - 1 + left.width() ) + i * 2, k,   /* capacities */ p_a, a_p );

		    // $B%N!<%I(Bq$B$+$i%N!<%I(Ba$B$N%(%C%8$N=E$_$K(B10000$B$r@_Dj(B
		    q_a = 10000;

		    // $B%N!<%I(Ba$B$+$i%N!<%I(Bq$B$N%(%C%8$N=E$_$K(B, V($B&A(Bp, $B&B(Bq) - V($B&A(Bp, $B&A(Bq)$B$+(B0$B$N$&$ABg$-$$$[$&$r@_Dj(B
		    vap_bq = c * abs( A[alpha][ap] - bq );

		    if( vap_bq - vap_aq > 0 )
		      a_q = vap_bq - vap_aq;
		    else
		      a_q = 0;

		    g -> add_edge( k, ( j + 1 ) * ( left.width() + left.width() - 1 + left.width() ) + i * 2,  /* capacities */ a_q, q_a );
		  }		     	
		
	      }
	
      
	  /**************************************************************************/	   
      

	  //fprintf(stderr,"graph_definition\n");
	  // $B:GBgN.!&:G>.%+%C%H%"%k%4%j%:%`$NE,MQ(B
	  int flow = g -> maxflow();
      	  
	  // flow < E $B$J$i8=:_$N%i%Y%k$r5a$^$C$?%i%Y%k$K$7!$(BE = flow$B$K$7!$(Bsuccess = 1$B$K$9$k(B
	  if( flow < E )
	    {
	      fprintf(stderr, "alpha = %d\n", alpha);
	      // flow : $B5a$^$C$?%i%Y%k$G7W;;$7$?Am%3%9%H4X?t(B($B$?$V$s(B)  
	      fprintf(stderr,"Flow = %d\n", flow);
	  
	      E = flow;
	      
	      for( size_t j = 0; j < left.height(); j++)
		for( size_t i = 0; i < left.width(); i++)
		  {

		    k = j * ( left.width() + left.width() - 1 + left.width() ) + i * 2;
		    
		    if (g->what_segment(k) == GraphType::SOURCE)
		      {

			// $B=i4|2=(B 
			aq = 0; 
			difference = 100000;
			tdif = 0;
			
			for( int l = 0; l < 100; l++ )
			  {
			    if( A[alpha][l] != 0 )
			      {
				tdif = abs( tmp(i, j) - A[alpha][l] );
				if( tdif < difference )
				  {
				    difference = tdif;
				    aq = l;
				  }
			      }
			    else
			      {
				break;
			      }
			    
			  }

			// printf("tmp(%d, %d) = node%d is in the SOURCE set\n", i, j, k);
			tmp( i, j ) = A[alpha][aq];
			//fprintf(stderr, "tmp = %d\n", tmp(i,j));

		      }
		  }


	      // $B%a%G%#%"%s%U%#%k%?$G%N%$%:=|5n(B
	      mist::median( tmp, t_tmp, MEDIAN, 0 );

	      for( size_t j = 0; j < left.height(); j++ )
		for( size_t i = 0; i < left.width(); i++ )
		  {
		    tmp( i, j ) = t_tmp( i, j );
		  }	   
	      

	      success = 1;


	    }

	  // $B%0%i%U$N>C5n(B
	  delete g;
	}

      // success == 0$B$J$i(Bbreak;
      if( success == 0 ) 
	break;
  
    }
  
  // bmp$B7A<0$N2hA|%U%!%$%k$r=PNO(B 
  mist::write_bmp( tmp, "tmp.bmp" );

  mist::array2< double > shift( left.width(), left.height() );
  max = 0;
  min = 1000;

  // $BG;EY3,D4JQ49(B

  for( size_t j = 0; j < tmp.height(); j++ )
    {
      for( size_t i = 0; i < tmp.width(); i++ )
	{
	  if( max < tmp( i, j ) )
	    {
	      max = tmp( i, j );
	    }
	  if( min > tmp( i, j ) )
	    {
	      min = tmp( i, j );
	    }
	}
    }


  for( size_t j = 0; j < tmp.height(); j++ )
    {
      for( size_t i = 0; i < tmp.width(); i++ )
	{
	  if( tmp( i, j ) < min )
	    shift( i, j ) = SHIFTMIN;
	  else if( min <= tmp( i, j ) && tmp( i, j ) <= max )
	    {
	      shift( i, j ) = ( SHIFTMAX / ( (double)( max - min ) ) * ( (double)( tmp( i, j ) - min ) ) );
	    }
	  else if( max < tmp( i, j ) )
	    shift( i, j ) = SHIFTMAX; 
	}
    }

  for( size_t j = 0; j < out.height(); j++ )
    for( size_t i = 0; i < out.width(); i++ )
      {
	out( i, j ) = ( int )shift( i, j );
      }
  
  mist::write_bmp( out, "out.bmp" );
  
  time2 = clock();

  std::cout << "$B7W;;;~4V(B: " << (double)(time2 - time1) / CLOCKS_PER_SEC << std::endl;

  return 0;
}
